<script lang="ts">
	import '$lib/styles/app.css';
	import { onMount } from 'svelte';
	import { fade } from 'svelte/transition';
	import anime from 'animejs';

	let coin: HTMLImageElement;
	export let left: string = '0%';
	export let top = '0%';
	export let size = 80;
	export let zIndex = 0;
	export let duration = 3.6;
	export let durationRotateX = 2.5;

	$: if (zIndex === 1) {
		size = size * 0.8;
		duration = 4;
	}

	onMount(() => {
		if (coin) {
			anime({
				targets: coin,
				rotateX: 720,
				duration: 1500,
				easing: 'easeInOutQuad',
				loop: true
			});
		}
	});
</script>

<div
	class="coin"
	style={`left:${left}; top:${top}; --size: ${size}px; --duration: ${duration}s;  --durationRotateX: ${durationRotateX}s; z-index:${zIndex}`}
	in:fade={{ delay: 1000 }}
>
	<img src="https://cdn-icons-png.flaticon.com/512/11280/11280638.png" alt="" />
</div>

<style>
	.coin {
		position: absolute;
		border-radius: 50%;
		animation-duration: var(--duration);
		animation-name: fallAnimation;
		animation-timing-function: ease-in-out;
		animation-iteration-count: 1;
		animation-fill-mode: forwards;
	}
	.coin img {
		width: var(--size);
		height: var(--size);
		animation-duration: var(--durationRotateX);
		animation-name: rotateAnimation;
		animation-timing-function: linear;
		animation-iteration-count: infinite;
	}

	@keyframes rotateAnimation {
		0% {
			transform: rotateX(0deg);
		}
		100% {
			transform: rotateX(720deg);
		}
	}

	@keyframes fallAnimation {
		0% {
			transform: translateY(-10vh);
			opacity: 0;
		}
		30% {
			opacity: 1;
		}
		80% {
			opacity: 0.5;
		}
		100% {
			transform: translateY(100vh);
			opacity: 0;
			display: none;
		}
	}
</style>
